config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  root to: 'activities#index'
  get '/activities', to: redirect('/')
  resources :actors, only: [:index, :show] do
    collection do
      get :lookup, to: 'actors#lookup'
    end
    resources :activities, only: [:index]
  end
  get :feed, to: 'activities#feed'
  resources :followings, only: [:create, :destroy] do
    collection do
      post :follow, to: 'followings#follow'
    end

    member do
      put :accept, to: 'followings#accept'
    end
  end
  resources :notes
  resources :users, except: [:new, :create, :destroy]

  get '/.well-known/webfinger', to: 'web_finger#find', as: :webfinger
  get '/.well-known/host-meta', to: 'web_finger#host_meta', as: :host_meta
  get '/.well-known/nodeinfo', to: 'web_finger#node_info', as: :node_info
  get '/nodeinfo/2.0', to: 'web_finger#show_node_info', as: :show_node_info

  namespace :federation do
    resources :actors, only: [:show] do
      member do
        get :followers
        get :following
      end
      get :outbox, to: 'activities#outbox'
      post :inbox, to: 'activities#create'
      resources :activities, only: [:show]
      resources :followings, only: [:show]
      resources :notes, only: [:show]
    end
  end
end

app/models/actor.rb
require 'utils/host'
require 'fediverse/webfinger'

class Actor < ApplicationRecord
  include Routeable

  validates :federated_url, presence: { unless: :user_id }, uniqueness: { unless: :user_id }
  validates :username, presence: { unless: :user_id }
  validates :server, presence: { unless: :user_id }
  validates :inbox_url, presence: { unless: :user_id }
  validates :outbox_url, presence: { unless: :user_id }
  validates :followers_url, presence: { unless: :user_id }
  validates :followings_url, presence: { unless: :user_id }
  validates :profile_url, presence: { unless: :user_id }
  validates :user_id, uniqueness: true, if: :local?

  belongs_to :user, optional: true
  has_many :notes, dependent: :destroy
  # FIXME: Handle this with something like undelete
  has_many :activities, dependent: :destroy
  has_many :following_followers, class_name: 'Following', foreign_key: :target_actor_id, dependent: :destroy, inverse_of: :target_actor
  has_many :following_follows, class_name: 'Following', dependent: :destroy, inverse_of: :actor
  has_many :followers, source: :actor, through: :following_followers
  has_many :follows, source: :target_actor, through: :following_follows

  scope :local, -> { where.not(user_id: nil) }

  def local?
    user_id.present?
  end

  def federated_url
    local? ? federation_actor_url(self) : attributes['federated_url'].presence
  end

  def username
    local? ? user.username : attributes['username']
  end

  def name
    local? ? user.name : attributes['name'] || username
  end

  def server
    local? ? Utils::Host.localhost : attributes['server']
  end

  def inbox_url
    local? ? federation_actor_inbox_url(self) : attributes['inbox_url']
  end

  def outbox_url
    local? ? federation_actor_outbox_url(self) : attributes['inbox_url']
  end

  def followers_url
    local? ? followers_federation_actor_url(self) : attributes['followers_url']
  end

  def followings_url
    local? ? following_federation_actor_url(self) : attributes['followings_url']
  end

  def profile_url
    local? ? user_url(user) : attributes['profile_url'].presence
  end

  def at_address
    "#{username}@#{server}"
  end

  def short_at_address
    local? ? "@#{username}" : at_address
  end

  def follows?(actor)
    list = following_follows.where target_actor: actor
    return list.first if list.count == 1

    false
  end

  class << self
    def find_by_account(account)
      parts = Fediverse::Webfinger.split_account account

      if Fediverse::Webfinger.local_user? parts
        actor = User.find_by!(username: parts[:username]).actor
      else
        actor = find_by username: parts[:username], server: parts[:domain]
        actor ||= Fediverse::Webfinger.fetch_actor(parts[:username], parts[:domain])
      end

      actor
    end

    def find_by_federation_url(federated_url)
      local_route = Utils::Host.local_route federated_url
      return find local_route[:id] if local_route && local_route[:controller] == 'federation/actors' && local_route[:action] == 'show'

      actor = find_by federated_url: federated_url
      actor ||= Fediverse::Webfinger.fetch_actor_url(federated_url)

      actor
    end

    def find_or_create_by_account(account)
      actor = find_by_account account
      # Create/update distant actors
      actor.save! unless actor.local?

      actor
    end

    def find_or_create_by_federation_url(url)
      actor = find_by_federation_url url
      # Create/update distant actors
      actor.save! unless actor.local?

      actor
    end

    # Find or create actor from a given actor hash or actor id (actor's URL)
    def find_or_create_by_object(object)
      case object
      when String
        find_or_create_by_federation_url object
      when Hash
        find_or_create_by_federation_url object['id']
      else
        raise "Unsupported object type for actor (#{object.class})"
      end
    end
  end
end

app/controllers/actors_controller.rb
class ActorsController < ApplicationController
  before_action :set_actor, only: [:show]

  # GET /actors
  # GET /actors.json
  def index
    @actors = policy_scope Actor.all
  end

  # GET /actors/1
  # GET /actors/1.json
  def show; end

  # GET /explorer/lookup
  # GET /explorer/lookup.json
  def lookup
    @actor = Actor.find_by_account account_param
    authorize @actor
    render :show
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_actor
    @actor = Actor.find(params[:id])
    authorize @actor
  end

  def account_param
    params.require('account')
  end
end

app/controllers/federation/actors_controller.rb
module Federation
  class ActorsController < FederationApplicationController
    before_action :set_federation_actor, only: [:show, :followers, :following]

    # GET /federation/actors/1
    # GET /federation/actors/1.json
    def show; end

    def followers
      @actors = @actor.followers.order(created_at: :desc)
      followings_queries
    end

    def following
      @actors = @actor.follows.order(created_at: :desc)
      followings_queries
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_federation_actor
      @actor = Actor.find(params[:id])
      authorize @actor
    end

    def followings_queries
      @total_actors = @actors.count
      @actors       = @actors.page(params[:page])
    end
  end
end

app/views/actors/_lookup_form.html.haml
= form_tag lookup_actors_path, method: :get do
  .field
    = label_tag :account
    = text_field_tag :account, nil, placeholder: 'user@domain.tld or username', required: true
  .actions
    = submit_tag 'Search'

app/views/actors/index.html.haml
%h1 Listing actors

%table
  %thead
    %tr
      %th Name
      %th Username
      %th Profile url
      %th Federation address
      %th Local?
      %th

  %tbody
    - @actors.each do |actor|
      %tr
        %td= actor.name
        %td= actor.username
        %td
          - if actor.profile_url
            = link_to 'Profile', actor.profile_url
        %td= actor.at_address
        %td= actor.local?
        %td
          = link_to 'Show', actor

app/views/actors/show.html.haml
%h2= @actor.name

- if policy(Following).create?
  %p
    - follow = current_user.follows? @actor
    - if @actor.user_id == current_user.id
      %button{ role: :button, disabled: true } That's you
    - elsif follow
      Already following (#{follow.status})
      = button_to 'Revoke', following_path(follow), method: :delete
    - else
      = button_to 'Follow!', follow_followings_path, params: { account: @actor.at_address }, method: :post

%p
  %b Federated url:
  = @actor.federated_url
%p
  %b Username:
  = @actor.username
%p
  %b Inbox URL:
  = @actor.inbox_url
%p
  %b Outbox URL:
  = @actor.outbox_url
%p
  %b Followers URL:
  = @actor.followers_url
%p
  %b Followings URL:
  = @actor.followings_url
%p
  %b Profile url:
  - if @actor.profile_url
    = link_to 'Profile', @actor.profile_url
%p
  %b Federation address:
  = @actor.at_address
%p
  %b Home page:
  - if @actor.local?
    = link_to @actor.user.name, @actor.user
  - elsif @actor.profile_url
    = link_to @actor.name, @actor.profile_url
  - else
    (No homepage)

%hr

%h2 Follows
- if current_user && current_user.id == @actor.user_id
  = render 'followings/form', following: Following.new
- @actor.following_follows.each do |following|
  = render 'followings/follow', following: following

%h2 Followers
- @actor.following_followers.each do |following|
  = render 'followings/follower', following: following

= link_to 'Back', actors_path

-# FIXME: Fetch distant content somehow
%h2 10 last activities
- if @actor.local?
  = link_to 'All', actor_activities_path(@actor)
- elsif @actor.profile_url
  = link_to 'Visit profile', @actor.profile_url
- @actor.activities.last(10).each do |activity|
  = render 'activities/activity', activity: activity